Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component.cpp	(revision 50)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component.cpp	(revision 53)
@@ -12,4 +12,6 @@
 @NAMESPACE_BEGIN
 
+#undef  FUNCTION
+#define FUNCTION "@COMPONENT::@COMPONENT"
 #ifdef SYSTEMC
   @COMPONENT::@COMPONENT (sc_module_name name,
@@ -18,7 +20,7 @@
 #endif
 #ifdef STATISTICS
-			      morpheo::behavioural::Parameters_Statistics             param_statistics,
+			  morpheo::behavioural::Parameters_Statistics * param_statistics,
 #endif
-			      morpheo::behavioural::@NAMESPACE_USE::Parameters param ):
+			  morpheo::behavioural::@NAMESPACE_USE::Parameters * param ):
 			      _name              (name)
 			      ,_param            (param)
@@ -27,8 +29,8 @@
 // #endif
   {
-    log_printf(FUNC,@COMPONENT,"@COMPONENT","Begin");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"Begin");
 
 #ifdef SYSTEMC
-    log_printf(INFO,@COMPONENT,"@COMPONENT","Allocation");
+    log_printf(INFO,@COMPONENT,FUNCTION,"Allocation");
 
     allocation ();
@@ -36,5 +38,5 @@
 
 #ifdef STATISTICS
-    log_printf(INFO,@COMPONENT,"@COMPONENT","Allocation of statistics");
+    log_printf(INFO,@COMPONENT,FUNCTION,"Allocation of statistics");
 
     // Allocation of statistics
@@ -46,5 +48,5 @@
 #ifdef VHDL
     // generate the vhdl
-    log_printf(INFO,@COMPONENT,"@COMPONENT","Generate the vhdl");
+    log_printf(INFO,@COMPONENT,FUNCTION,"Generate the vhdl");
 
     vhdl();
@@ -53,5 +55,5 @@
 #ifdef SYSTEMC
 //#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
-    log_printf(INFO,@COMPONENT,"@COMPONENT","Method - transition");
+    log_printf(INFO,@COMPONENT,FUNCTION,"Method - transition");
 
     SC_METHOD (transition);
@@ -65,13 +67,15 @@
 
 #endif
-    log_printf(FUNC,@COMPONENT,"@COMPONENT","End");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"End");
   };
   
+#undef  FUNCTION
+#define FUNCTION "@COMPONENT::~@COMPONENT"
   @COMPONENT::~@COMPONENT (void)
   {
-    log_printf(FUNC,@COMPONENT,"~@COMPONENT","Begin");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"Begin");
 
 #ifdef STATISTICS
-    log_printf(INFO,@COMPONENT,"~@COMPONENT","Generate Statistics file");
+    log_printf(INFO,@COMPONENT,FUNCTION,"Generate Statistics file");
 
     _stat->generate_file(statistics(0));
@@ -81,10 +85,10 @@
 
 #ifdef SYSTEMC
-    log_printf(INFO,@COMPONENT,"~@COMPONENT","Deallocation");
+    log_printf(INFO,@COMPONENT,FUNCTION,"Deallocation");
 
     deallocation ();
 #endif
 
-    log_printf(FUNC,@COMPONENT,"~@COMPONENT","End");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"End");
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_allocation.cpp	(revision 50)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_allocation.cpp	(revision 53)
@@ -13,9 +13,12 @@
 @NAMESPACE_BEGIN
 
+
+#undef  FUNCTION
+#define FUNCTION "@COMPONENT::allocation"
   void @COMPONENT::allocation (void)
   {
     string rename;
 
-    log_printf(FUNC,@COMPONENT,"allocation","Begin");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"Begin");
 
     _component   = new Component ();
@@ -49,5 +52,5 @@
 #endif
 
-    log_printf(FUNC,@COMPONENT,"allocation","End");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"End");
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_deallocation.cpp	(revision 50)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_deallocation.cpp	(revision 53)
@@ -1,2 +1,5 @@
+#undef  FUNCTION
+#define FUNCTION "@COMPONENT::"
+
 #ifdef SYSTEMC
 /*
@@ -13,12 +16,14 @@
 @NAMESPACE_BEGIN
 
+#undef  FUNCTION
+#define FUNCTION "@COMPONENT::deallocation"
   void @COMPONENT::deallocation (void)
   {
-    log_printf(FUNC,@COMPONENT,"deallocation","Begin");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"Begin");
 
 //#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
-    delete in_CLOCK;
+    delete    in_CLOCK ;
 //#endif
-    delete in_NRESET;
+    delete    in_NRESET;
 
     // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
@@ -26,5 +31,5 @@
     delete _component;
 
-    log_printf(FUNC,@COMPONENT,"deallocation","End");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"End");
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_statistics.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_statistics.cpp	(revision 50)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_statistics.cpp	(revision 53)
@@ -13,11 +13,13 @@
 @NAMESPACE_BEGIN
 
+#undef  FUNCTION
+#define FUNCTION "@COMPONENT::statistics"
   string @COMPONENT::statistics (uint32_t depth)
   {
-    log_printf(FUNC,@COMPONENT,"statistics","Begin");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"Begin");
 
     string txt = _stat->print(depth);
     
-    log_printf(FUNC,@COMPONENT,"statistics","End");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"End");
 
     return txt;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_transition.cpp	(revision 50)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_transition.cpp	(revision 53)
@@ -14,7 +14,9 @@
 @NAMESPACE_BEGIN
 
+#undef  FUNCTION
+#define FUNCTION "@COMPONENT::transition"
   void @COMPONENT::transition (void)
   {
-    log_printf(FUNC,@COMPONENT,"transition","Begin");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"Begin");
 
 #ifdef STATISTICS
@@ -26,5 +28,5 @@
 #endif
 
-    log_printf(FUNC,@COMPONENT,"transition","End");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"End");
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_vhdl.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_vhdl.cpp	(revision 50)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_vhdl.cpp	(revision 53)
@@ -14,7 +14,9 @@
 @NAMESPACE_BEGIN
 
+#undef  FUNCTION
+#define FUNCTION "@COMPONENT::vhdl"
   void @COMPONENT::vhdl (void)
   {
-    log_printf(FUNC,@COMPONENT,"vhdl","Begin");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"Begin");
 
     Vhdl * vhdl = new Vhdl (_name);
@@ -30,5 +32,5 @@
     delete vhdl;
 
-    log_printf(FUNC,@COMPONENT,"vhdl","End");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"End");
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_vhdl_body.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_vhdl_body.cpp	(revision 50)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_vhdl_body.cpp	(revision 53)
@@ -13,9 +13,11 @@
 @NAMESPACE_BEGIN
 
+#undef  FUNCTION
+#define FUNCTION "@COMPONENT::vhdl_body"
   void @COMPONENT::vhdl_body (Vhdl * & vhdl)
   {
-    log_printf(FUNC,@COMPONENT,"vhdl_body","Begin");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"Begin");
     vhdl->set_body ("");
-    log_printf(FUNC,@COMPONENT,"vhdl_body","End");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"End");
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_vhdl_declaration.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_vhdl_declaration.cpp	(revision 50)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_vhdl_declaration.cpp	(revision 53)
@@ -13,8 +13,10 @@
 @NAMESPACE_BEGIN
 
+#undef  FUNCTION
+#define FUNCTION "@COMPONENT::vhdl_declaration"
   void @COMPONENT::vhdl_declaration (Vhdl * & vhdl)
   {
-    log_printf(FUNC,@COMPONENT,"vhdl_declaration","Begin");
-    log_printf(FUNC,@COMPONENT,"vhdl_declaration","End");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"Begin");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"End");
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_vhdl_testbench_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_vhdl_testbench_transition.cpp	(revision 50)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/New_Component_vhdl_testbench_transition.cpp	(revision 53)
@@ -13,7 +13,9 @@
 @NAMESPACE_BEGIN
 
+#undef  FUNCTION
+#define FUNCTION "@COMPONENT::vhdl_testbench_transition"
   void @COMPONENT::vhdl_testbench_transition ()
   {
-    log_printf(FUNC,@COMPONENT,"vhdl_testbench_transition","Begin");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"Begin");
 
     // Evaluation before read the ouput signal
@@ -22,5 +24,5 @@
     _interfaces->testbench();
 
-    log_printf(FUNC,@COMPONENT,"vhdl_testbench_transition","End");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"End");
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/Parameters.cpp	(revision 50)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/Parameters.cpp	(revision 53)
@@ -12,22 +12,28 @@
 @NAMESPACE_BEGIN
 
+#undef  FUNCTION
+#define FUNCTION "@COMPONENT::Parameters"
   Parameters::Parameters ()
   {
-    log_printf(FUNC,@COMPONENT,"Parameters","Begin");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"Begin");
     test();
-    log_printf(FUNC,@COMPONENT,"Parameters","End");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"End");
   };
   
+#undef  FUNCTION
+#define FUNCTION "@COMPONENT::Parameters (copy)"
   Parameters::Parameters (Parameters & param)
   {
-    log_printf(FUNC,@COMPONENT,"Parameters (copy)","Begin");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"Begin");
     test();
-    log_printf(FUNC,@COMPONENT,"Parameters (copy)","End");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"End");
   };
 
+#undef  FUNCTION
+#define FUNCTION "@COMPONENT::~Parameters"
   Parameters::~Parameters () 
   {
-    log_printf(FUNC,@COMPONENT,"~Parameters","Begin");
-    log_printf(FUNC,@COMPONENT,"~Parameters","End");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"Begin");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"End");
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/Parameters_msg_error.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/Parameters_msg_error.cpp	(revision 50)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/Parameters_msg_error.cpp	(revision 53)
@@ -15,7 +15,9 @@
 @NAMESPACE_BEGIN
 
+#undef  FUNCTION
+#define FUNCTION "@COMPONENT::msg_error"
   string Parameters::msg_error(void)
   {
-    log_printf(FUNC,@COMPONENT,"msg_error","Begin");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"Begin");
 
     string msg = "";
@@ -23,5 +25,5 @@
     return msg;
 
-    log_printf(FUNC,@COMPONENT,"msg_error","End");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"End");
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/Parameters_print.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/Parameters_print.cpp	(revision 50)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/Parameters_print.cpp	(revision 53)
@@ -14,25 +14,32 @@
 @NAMESPACE_BEGIN
 
+#undef  FUNCTION
+#define FUNCTION "@COMPONENT::print"
   string Parameters::print (uint32_t depth)
   {
-    log_printf(FUNC,@COMPONENT,"print","Begin");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"Begin");
 
     XML xml ("@COMPONENT_LOWER");
 
     xml.balise_open("@COMPONENT_LOWER");
-//  xml.singleton_begin("size_data"); xml.attribut("value",toString(_size_data)); xml.singleton_end();
-//  xml.singleton_begin("nb_port  "); xml.attribut("value",toString(_nb_port  )); xml.singleton_end();
+//  xml.singleton_begin(""); xml.attribut("value",toString(_)); xml.singleton_end();
     xml.balise_close();
 
-    log_printf(FUNC,@COMPONENT,"print","End");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"End");
     
     return xml.get_body(depth);
   };
 
+#undef  FUNCTION
+#define FUNCTION "@COMPONENT::operator<<"
   ostream& operator<< (ostream& output_stream ,
 		       morpheo::behavioural::@NAMESPACE_USE::Parameters & x)
   {
+    log_printf(FUNC,@COMPONENT,FUNCTION,"Begin");
+
     output_stream << x.print(0);
     
+    log_printf(FUNC,@COMPONENT,FUNCTION,"End");
+
     return output_stream;
   };
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/Statistics.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/Statistics.cpp	(revision 50)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/Statistics.cpp	(revision 53)
@@ -13,7 +13,9 @@
 @NAMESPACE_BEGIN
 
-  Statistics::Statistics (string                                      name                       ,
-			  morpheo::behavioural::Parameters_Statistics parameters_statistics      ,
-			  Parameters                                  parameters
+#undef  FUNCTION
+#define FUNCTION "@COMPONENT::Statistics"
+  Statistics::Statistics (string                                        name                       ,
+			  morpheo::behavioural::Parameters_Statistics * parameters_statistics      ,
+			  Parameters                                  * parameters
 			  ) :
     morpheo::behavioural::Statistics(name                  ,
@@ -21,12 +23,14 @@
     _parameters(parameters)
   {
-    log_printf(FUNC,@COMPONENT,"Statistics","Begin");
-    log_printf(FUNC,@COMPONENT,"Statistics","End");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"Begin");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"End");
   };
   
+#undef  FUNCTION
+#define FUNCTION "@COMPONENT::~Statistics"
   Statistics::~Statistics () 
   { 
-    log_printf(FUNC,@COMPONENT,"~Statistics","Begin");
-    log_printf(FUNC,@COMPONENT,"~Statistics","End");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"Begin");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"End");
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/Statistics_add.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/Statistics_add.cpp	(revision 50)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/Statistics_add.cpp	(revision 53)
@@ -16,8 +16,10 @@
 @NAMESPACE_BEGIN
 
+#undef  FUNCTION
+#define FUNCTION "@COMPONENT::add"
   void Statistics::add ()
   {
-    log_printf(FUNC,@COMPONENT,"add","Begin");
-    log_printf(FUNC,@COMPONENT,"add","End");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"Begin");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"End");
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/Statistics_print.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/Statistics_print.cpp	(revision 50)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/Statistics_print.cpp	(revision 53)
@@ -16,7 +16,9 @@
 @NAMESPACE_BEGIN
 
+#undef  FUNCTION
+#define FUNCTION "@COMPONENT::print"
   string Statistics::print (uint32_t depth)
   {
-    log_printf(FUNC,@COMPONENT,"print","Begin");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"Begin");
 
     string        tab = string(depth,'\t');
@@ -27,13 +29,19 @@
 	<< tab << "</@COMPONENT_LOWER>" << endl;
     
-    log_printf(FUNC,@COMPONENT,"print","End");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"End");
 
     return msg.str();
   };
 
+#undef  FUNCTION
+#define FUNCTION "@COMPONENT::operator<<"
   ostream& operator<< (ostream& output_stream ,
 		       morpheo::behavioural::@NAMESPACE_USE::Statistics & x)
   {
+    log_printf(FUNC,@COMPONENT,FUNCTION,"Begin");
+
     output_stream << x.print(0);
+
+    log_printf(FUNC,@COMPONENT,FUNCTION,"End");
 
     return output_stream;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/Statistics_print_body.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/Statistics_print_body.cpp	(revision 50)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component/src/Statistics_print_body.cpp	(revision 53)
@@ -16,7 +16,9 @@
 @NAMESPACE_BEGIN
 
+#undef  FUNCTION
+#define FUNCTION "@COMPONENT::print_body"
   string Statistics::print_body (uint32_t depth)
   {
-    log_printf(FUNC,@COMPONENT,"print_body","Begin");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"Begin");
 
     string        tab = string(depth,'\t');
@@ -25,5 +27,5 @@
     msg << tab << "";
     
-    log_printf(FUNC,@COMPONENT,"print_body","End");
+    log_printf(FUNC,@COMPONENT,FUNCTION,"End");
 
     return msg.str();